<!DOCTYPE html>
<html>

<head>
    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Vùng header -->
    <div class="container">
        <div class="text-center">
            <h2>F120 - Quản trị Users</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; New User</button>
        </div>
    </div>
    <!-- User Data Table -->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="users-table">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- Create user modal -->
    <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <label for="input-create-firstname" class="col-form-label col-sm-4">Firstname</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-firstname" name="Firstname"
                                        placeholder="Firstname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="input-create-lastname" class="col-form-label col-sm-4">Lastname</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-lastname" name="Lastname" placeholder="Lastname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-create-country" class="col-form-label col-sm-4">Country</label>
                                <div class="col-sm-8">
                                    <select name="Country" id="select-create-country" class="form-control">
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="Can">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-create-customer-type" class="col-form-label col-sm-4">Customer
                                    Type</label>
                                <div class="col-sm-8">
                                    <select name="CustomerType" id="select-create-customer-type" class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="input-create-subject" class="col-form-label col-sm-4">Subject</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-subject" name="Subject" placeholder="Subject"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-create-user">Create user</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Edit user modal -->
    <div>
        <div id="edit-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Edit user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <label for="input-edit-firstname" class="col-form-label col-sm-4">Firstname</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-edit-firstname" name="Firstname"
                                        placeholder="Firstname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="input-edit-lastname" class="col-form-label col-sm-4">Lastname</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-edit-lastname" name="Lastname" placeholder="Lastname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-edit-country" class="col-form-label col-sm-4">Country</label>
                                <div class="col-sm-8">
                                    <select name="Country" id="select-edit-country" class="form-control">
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="Can">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-edit-customer-type" class="col-form-label col-sm-4">Customer
                                    Type</label>
                                <div class="col-sm-8">
                                    <select name="CustomerType" id="select-edit-customer-type" class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="select-edit-register-status" class="col-form-label col-sm-4">Register
                                    Status</label>
                                <div class="col-sm-8">
                                    <select name="RegisterStatus" id="select-edit-register-status" class="form-control">
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <label for="input-edit-subject" class="col-form-label col-sm-4">Subject</label>
                                <div class="col-sm-8">
                                    <input type="text" id="input-edit-subject" name="Subject" placeholder="Subject"
                                        class="form-control">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-edit-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-edit-user">Edit user</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">User Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    var gUserId = 0;

    const gUSER_COL = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

    const gUSER_ID_COL = 0;
    const gUSER_FIRSTNAME_COL = 1;
    const gUSER_LASTNAME_COL = 2;
    const gUSER_COUNTRY_COL = 3;
    const gUSER_SUBJECT_COL = 4;
    const gUSER_CUSTOMER_TYPE_COL = 5;
    const gUSER_REGISTER_STATUS_COL = 6;
    const gUSER_ACTION_COL = 7;

    var gUserTable = $("#users-table").DataTable({
        columns: [
            { data: gUSER_COL[gUSER_ID_COL] },
            { data: gUSER_COL[gUSER_FIRSTNAME_COL] },
            { data: gUSER_COL[gUSER_LASTNAME_COL] },
            { data: gUSER_COL[gUSER_COUNTRY_COL] },
            { data: gUSER_COL[gUSER_SUBJECT_COL] },
            { data: gUSER_COL[gUSER_CUSTOMER_TYPE_COL] },
            { data: gUSER_COL[gUSER_REGISTER_STATUS_COL] },
            { data: gUSER_COL[gUSER_ACTION_COL] }
        ],
        columnDefs: [
            {
                targets: gUSER_ACTION_COL,
                defaultContent: `
        <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
        <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
      `
            }
        ]
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
    });
    $("#users-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
    });
    $("#users-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
    });
    $("#btn-add-user").on("click", function () {
        onBtnAddUserClick();
    });
    $("#btn-create-user").on("click", function () {
        onBtnCreateUserClick();
    });
    $("#btn-edit-user").on("click", function () {
        onBtnConfirmEditClick();
    });
    $("#btn-confirm-delete-user").on("click", function () {
        onBtnConfirmDeleteClick();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        getApiUsers();
    }
    function onBtnEditUserClick(paramEdit) {
        gUserId = getUserIdFormButton(paramEdit);
        console.log("Id user = " + gUserId);
        getUserById(gUserId);
    }
    function onBtnDeleteUserClick(paramDelete) {
        gUserId = getUserIdFormButton(paramDelete);
        console.log("Id user = " + gUserId);
        $("#delete-confirm-modal").modal("show");
    }
    function onBtnAddUserClick() {
        $("#create-user-modal").modal("show");
    }
    function onBtnCreateUserClick() {
        // khai báo đối tượng chứa user data
        var vObjUser = {
            firstName: "",
            lastName: "",
            subject: "",
            country: "",
            customerType: ""
        };
        // B1: Thu thập dữ liệu
        getCreateUserData(vObjUser);
        // B2: Validate user
        var vValid = checkUserData(vObjUser);
        //console.log(vValid);
        if (vValid) {
            // B3: create user
            $.ajax({
                url: gBASE_URL,
                type: "POST",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vObjUser),
                success: function (paramRes) {
                    console.log(paramRes);
                    // B4: xử lý front-end
                    handleCreateUserSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }
    function onBtnConfirmEditClick() {
        // khai báo đối tượng chứa user data
        var vUserObj = {
            firstName: "",
            lastName: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: ""
        };
        // B1: Thu thập dữ liệu
        getEditUserData(vUserObj);
        // B2: Validate user
        var vIsEditValidate = checkUserData(vUserObj);
        if (vIsEditValidate) {
            // B3: update user
            $.ajax({
                url: gBASE_URL + gUserId,
                type: "PUT",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vUserObj),
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleEditUserSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
        }
    }
    function onBtnConfirmDeleteClick(){
        // B1: Thu thập dữ liệu(ko cần)
        // B2: Validate user(ko cần)
        // B3: update user
        $.ajax({
        url: gBASE_URL + gUserId,
        type: "DELETE",
        success: function () {
          // B4: xử lý front-end
          handleDeleteVoucherSuccess();
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function loadDataToUserTable(paramUsers) {
        gUserTable.clear();
        gUserTable.rows.add(paramUsers);
        gUserTable.draw();
    }
    function getApiUsers() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramUser) {
                console.log(paramUser);
                loadDataToUserTable(paramUser);
            },
            error: function (pramErr) {
                console.log(pramErr.status);
            }
        });
    }

    function getUserIdFormButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        return vUserRowData.id;
    }

    function getUserById(paramUserId) {

        $.ajax({
            url: gBASE_URL + paramUserId,
            type: "GET",
            success: function (paramUser) {
                showUserDataToModal(paramUser);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        });
        // hiển thị modal lên
        $("#edit-user-modal").modal("show");
    }

    function getCreateUserData(paramDataUser) {
        paramDataUser.firstName = $("#input-create-firstname").val().trim();
        paramDataUser.lastName = $("#input-create-lastname").val().trim();
        paramDataUser.country = $("#select-create-country").val();
        paramDataUser.customerType = $("#select-create-customer-type").val();
        paramDataUser.subject = $("#input-create-subject").val().trim();
    }

    function getEditUserData(paramDataUser) {
        paramDataUser.firstName = $("#input-edit-firstname").val().trim();
        paramDataUser.lastName = $("#input-edit-lastname").val().trim();
        paramDataUser.country = $("#select-edit-country").val();
        paramDataUser.customerType = $("#select-create-customer-type").val();
        paramDataUser.registerStatus = $("#select-edit-register-status").val();
        paramDataUser.subject = $("#input-edit-subject").val().trim();
    }

    function showUserDataToModal(paramUser) {
        debugger;
        $("#input-edit-firstname").val(paramUser.firstname);
        $("#input-edit-lastname").val(paramUser.lastname);
        $("#select-edit-country").val(paramUser.country);
        $("#select-edit-customer-type").val(paramUser.customerType);
        $("#select-edit-register-status").val(paramUser.registerStatus);
        $("#input-edit-subject").val(paramUser.subject);
    }

    function checkUserData(paramDataUser) {
        if (paramDataUser.firstName === "") {
            alert("Nhập firstname");
            return false;
        }
        if (paramDataUser.lastName === "") {
            alert("Nhập lastname");
            return false;
        }
        if (paramDataUser.subject === "") {
            alert("Nhập subject");
            return false;
        }
        return true;
    }
    
    function deleteUser(paramUser){
        var vUserIndex = getUserById
    }
    function handleCreateUserSuccess() {
        alert("Thành công thêm user");
        getApiUsers();
        resetCreateUserForm();
        $("#create-user-modal").modal("hide");
    }
    function resertCreateVoucherForm() {
        $("#input-create-firstname").val();
        $("#input-create-lastname").val();
        $("#input-create-subject").val();
        $("#select-create-customer-type").val("Standard");
        $("#select-create-country").val("VN");
    }

    function resertEditUserForm() {
        $("#input-edit-firstname").val("");
        $("#input-edit-lastname").val("");
        $("#input-edit-subject").val("");
        $("#select-edit-customer-type").val("Standard");
        $("#select-edit-country").val("VN");
        $("#select-edit-register-status").val("New");
    }

    function handleEditUserSuccess() {
        alert("Sửa user thành công!");
        getApiUsers();
        resertEditUserForm();
        $("#edit-user-modal").modal("hide");
    }
    function handleDeleteVoucherSuccess(){
        alert("Delete user thành công!");
        getApiUsers();
        resertEditUserForm();
        $("#delete-confirm-modal").modal("hide");
    }
</script>

</html>